﻿--[[
]]

local LootMaster    = LibStub("AceAddon-3.0"):GetAddon("LootMaster")

local LOOTBUTTON_MAXNUM = 10
local LOOTBUTTON_HEIGHT = 32
local LOOTBUTTON_PADDING = 8

-- Column for the scrollingTable
local gearBgColor   = {["r"] = 0.15, ["g"] = 0.15, ["b"] = 0.15, ["a"] = 1.0 }
local epgpColor     = {["r"] = 0.55, ["g"] = 0.55, ["b"] = 0.55, ["a"] = 1.0 }
local sstScrollCols = {
	   { ["name"] = "Candidate",		["width"] = 100, ["align"] = "LEFT" },	   
       { ["name"] = "Rank",     		["width"] = 100, ["align"] = "LEFT" },
	   { ["name"] = "Response",		    ["width"] = 200, ["align"] = "LEFT", 	["defaultsort"] = "desc", ["sort"] = "desc", ["color"] = {["r"] = 0.25, ["g"] = 1.00, ["b"] = 0.25, ["a"] = 1.0 }, ["sortnext"]=8 }, --, 
       { ["name"] = "EP",		        ["width"] = 45,  ["align"] = "RIGHT",   ["color"] = epgpColor},
       { ["name"] = "GP",		        ["width"] = 45,  ["align"] = "RIGHT",   ["color"] = epgpColor},
       { ["name"] = "PR",		        ["width"] = 45,  ["align"] = "RIGHT",   ["defaultsort"] = "asc", ["sort"] = "asc", ["sortnext"]=7},
       { ["name"] = "Roll",		        ["width"] = 35,  ["align"] = "RIGHT",   ["defaultsort"] = "asc", ["sort"] = "asc", ["color"] = epgpColor},
       
       { ["name"] = " ",		        ["width"] = 5,   ["align"] = "LEFT",    ["defaultsort"] = "asc", ["sort"] = "asc", ["sortnext"]=6},   -- Spacer, actually contains a check if someone matches MinEP, used for sorting purposes.
       
       { ["name"] = "iLvl",		        ["width"] = 60,  ["align"] = "CENTER",  ["bgcolor"] = gearBgColor },
       { ["name"] = "GP",		        ["width"] = 60,  ["align"] = "CENTER",  ["bgcolor"] = gearBgColor },
       { ["name"] = "s1",		        ["width"] = 20,  ["align"] = "CENTER",  ["bgcolor"] = gearBgColor },
       { ["name"] = "s2",		        ["width"] = 20,  ["align"] = "CENTER",  ["bgcolor"] = gearBgColor },
       { ["name"] = " ",		        ["width"] = 5,   ["align"] = "LEFT",    ["bgcolor"] = gearBgColor }
}

function LootMasterML:GetFrame()
    
    if self.frame then
        return self.frame;
    end    
    
    local mainframe = CreateFrame("Frame","LootMasterMLMainFrame",UIParent)
    mainframe:SetPoint("CENTER",UIParent,"CENTER",0,0)
    mainframe:Hide();
    mainframe:SetMovable(true)
	mainframe:SetFrameStrata("DIALOG")
    self.mainframe = mainframe;
    
    local frame = CreateFrame("Frame","LootMasterMLFrame",mainframe)
    --#region Setup main masterlooter frame
    frame:Show();
    frame:SetPoint("TOPLEFT",mainframe,"TOPLEFT",0,0)
    frame:SetPoint("BOTTOMRIGHT",mainframe,"BOTTOMRIGHT",0,0)
	frame:SetWidth(700)
	frame:SetHeight(415)
	frame:SetPoint("CENTER",UIParent,"CENTER",0,0)
	frame:EnableMouse()
    frame:SetMovable(true)
	--frame:SetResizable()    
	
    --frame:SetToplevel(true)
    frame:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 64, edgeSize = 8,
		insets = { left = 2, right = 1, top = 2, bottom = 2 }
	})
    frame:SetBackdropColor(1,0,0,1)
    
    --frame:SetScript("OnMouseDown", function() mainframe:StartMoving() end)
	--frame:SetScript("OnMouseUp", function() mainframe:StopMovingOrSizing() end)
	--frame:SetScript("OnHide",frameOnClose)
    --#endregion
    
    local titleFrame = CreateFrame("Frame", nil, mainframe)
    --#region Setup main frame title
    titleFrame:SetBackdrop({
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 64, edgeSize = 8,
		insets = { left = 2, right = 1, top = 2, bottom = 2 }
	})  
    titleFrame:SetBackdropColor(0,0,0,1)
    titleFrame:SetHeight(22)
    titleFrame:EnableMouse()
    titleFrame:SetPoint("LEFT",mainframe,"TOPLEFT",20,0)
    titleFrame:SetPoint("RIGHT",mainframe,"TOPRIGHT",-20,0)
    titleFrame:SetToplevel(true)
    
    titleFrame:SetScript("OnMouseDown", function() mainframe:StartMoving() end)
	titleFrame:SetScript("OnMouseUp", function()
        mainframe:StopMovingOrSizing()
        if mainframe.lastClick and GetTime()-mainframe.lastClick<=0.5 then
            if frame:IsShown() then
                frame:Hide();
                titleFrame:ClearAllPoints()
                titleFrame:SetPoint("CENTER",mainframe,"TOP",0,0)
                titleFrame:SetWidth( titleFrame.titletext:GetWidth() + 20 );
            else
                frame:Show()
                titleFrame:ClearAllPoints()
                titleFrame:SetPoint("LEFT",mainframe,"TOPLEFT",20,0)
                titleFrame:SetPoint("RIGHT",mainframe,"TOPRIGHT",-20,0)
            end
            mainframe.lastClick = nil;
        else
            mainframe.lastClick = GetTime();
        end
    end)	
    
    local titletext = titleFrame:CreateFontString(nil,"OVERLAY","GameFontNormalSmall")
	titletext:SetPoint("CENTER",titleFrame,"CENTER",0,1)
	titletext:SetText( string.format("LootMaster %s by Bushmaster <Steel Alliance> - Twisting Nether EU", self:GetVersionString() ) )    
    titleFrame.titletext = titletext
    frame.titleFrame = titleFrame
    --#endregion
    
    local icon = CreateFrame("Button", nil, frame)
    --#region itemicon setup
    icon:EnableMouse()
    icon:SetNormalTexture("Interface/ICONS/INV_Misc_QuestionMark")
    icon:SetScript("OnEnter", function()
        if not frame.currentLoot then return end
        GameTooltip:SetOwner(frame, "ANCHOR_NONE")
        GameTooltip:SetHyperlink( frame.currentLoot.link )
        GameTooltip:SetPoint("TOPLEFT", frame , "TOPRIGHT", 0, -5);
	    GameTooltip:Show()        
    end);
    icon:SetScript("OnLeave", function()
	    GameTooltip:Hide()	
    end);
    icon:SetScript("OnClick", function()
        if not frame.currentLoot then return end
	    if ( IsModifiedClick() ) then
		    HandleModifiedItemClick(frame.currentLoot.link);
        end
    end);
    icon:SetPoint("TOPLEFT",frame,"TOPLEFT",10,-20)
    icon:SetHeight(48)
    icon:SetWidth(48)
    frame.itemIcon = icon;
    --#endregion
    
    local lblItem = frame:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	lblItem:SetPoint("TOPLEFT",icon,"TOPRIGHT",10,0)
    lblItem:SetVertexColor( 1, 1, 1 );
	lblItem:SetText( "Itemname" )    
    frame.lblItem = lblItem;
    
    local lblInfo = frame:CreateFontString(nil,"OVERLAY","GameFontNormalSmall")
	lblInfo:SetPoint("BOTTOMLEFT",lblItem,"BOTTOMRIGHT",5,0)
    lblInfo:SetVertexColor( 0.7, 0.7, 0.7 );
	lblInfo:SetText( "ItemInfo" )
    frame.lblInfo = lblInfo;
    
    local equipHeaderFrame = CreateFrame("Frame", nil, frame)
    --#region Setup the headerframe and text for the candidate equipment columns.
    equipHeaderFrame:SetBackdrop({
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		tile = true, tileSize = 64, edgeSize = 8,
		insets = { left = 2, right = 1, top = 2, bottom = 2 }
	})  
    equipHeaderFrame:SetBackdropColor(0.2,0.2,0.2,0.6)
    equipHeaderFrame:SetWidth(170)
    equipHeaderFrame:SetHeight(38)
    
    local titletext = equipHeaderFrame:CreateFontString(nil,"OVERLAY","GameFontNormalSmall")
    titletext:SetVertexColor( 0.9, 0.9, 0.9 );
	titletext:SetPoint("CENTER",equipHeaderFrame,"CENTER",0,0)
    titletext:SetPoint("TOP",equipHeaderFrame,"TOP",0,-5)
	titletext:SetText( string.format("Candidate's current equipment:", self:GetVersionString() ) )    
    --#endregion
    
	local sstScroll = ScrollingTable:CreateST(sstScrollCols, 15, 20, nil, frame);
    --#region Setup the scrollingTable
	sstScroll.frame:SetPoint("TOPLEFT",frame,"TOPLEFT",10,-95)	
	sstScroll.frame:SetPoint("RIGHT",frame,"RIGHT",-30,10)    
	frame:SetWidth( sstScroll.frame:GetWidth(width) + 37 )
    
    equipHeaderFrame:SetPoint("BOTTOMRIGHT",sstScroll.frame,"TOPRIGHT",-1,-5)

	frame:SetMinResize(frame:GetWidth(),130)
	frame:SetMaxResize(frame:GetWidth(), 60*15+85 )
    
    frame.sstScroll = sstScroll
    --#endregion
    
    local lblGPOverride = frame:CreateFontString(nil,"OVERLAY","GameFontNormal")
    --lblGPOverride:SetVertexColor( 0.9, 0.9, 0.9 );
	lblGPOverride:SetPoint("TOPLEFT",lblItem,"BOTTOMLEFT",0,-15)
	lblGPOverride:SetText( "GP value:" );
    frame.lblGPOverride = lblGPOverride
    
    local lblNoDistribute = frame:CreateFontString(nil,"OVERLAY","GameFontNormal")
    lblNoDistribute:SetVertexColor( 1, 0, 0 );
	lblNoDistribute:SetPoint("TOPLEFT",lblItem,"BOTTOMLEFT",0,-15)
	lblNoDistribute:SetText( "** MONITOR ONLY **" );
    frame.lblNoDistribute = lblNoDistribute
    
    local tbGPValueFrame = CreateFrame("Frame", nil, frame)    
	tbGPValueFrame:SetHeight(20)  
    tbGPValueFrame:SetWidth(50);
    tbGPValueFrame:SetBackdrop({
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 64, edgeSize = 8,
		insets = { left = 2, right = 1, top = 2, bottom = 2 }
	})
    tbGPValueFrame:SetBackdropColor(0.2, 0.2, 0.2, 1)
    tbGPValueFrame:SetBackdropBorderColor(1, 1, 1, 1)
    tbGPValueFrame:SetPoint("BOTTOMLEFT",lblGPOverride,"BOTTOMRIGHT",10,-5)
    
    local tbGPValue = CreateFrame("EditBox", nil, tbGPValueFrame)
    local iGPManual = 0
    tbGPValue:SetHistoryLines(1)
    tbGPValue:SetMaxLetters(5);
    tbGPValue:SetAutoFocus(false)
    tbGPValue:SetPoint("TOPLEFT",tbGPValueFrame,"TOPLEFT", 6, -1);
    tbGPValue:SetPoint("BOTTOMRIGHT",tbGPValueFrame,"BOTTOMRIGHT", -6, 1);
    tbGPValue:SetFontObject('GameFontHighlightSmall')
    tbGPValue:SetScript("OnEscapePressed", function() tbGPValue:ClearFocus() end)
    tbGPValue:SetScript("OnEnterPressed", function() tbGPValue:ClearFocus() end)
        
    tbGPValue:SetScript("OnEditFocusGained", function() tbGPValue:HighlightText(); CloseDropDownMenus(); end)
    tbGPValue:SetScript("OnEditFocusLost", function()
        tbGPValue:HighlightText(0,0)
        iGPManual = tonumber(tbGPValue:GetText()) or frame.currentLoot.gpvalue or 0;
        tbGPValue:SetText(iGPManual);
        frame.currentLoot.gpvalue_manual = iGPManual;        
    end)        
    tbGPValue:SetScript("OnTextChanged", function() CloseDropDownMenus(); end)    
    frame.tbGPValue = tbGPValue;
    frame.tbGPValueFrame = tbGPValueFrame;
    
    local btnAnnounce = CreateFrame("Button", nil, frame, "UIPanelButtonTemplate")
	btnAnnounce:SetScript("OnClick", function()
            if not frame.currentLoot then return message('no loot selected') end
            for candidate, index in pairs(frame.currentLoot.candidates) do
                if self:GetCandidateData( frame.currentLoot.id, candidate, 'response') == LootMaster.RESPONSE.NOTANNOUNCED then
                    self:AskCandidateIfNeeded( frame.currentLoot.id, candidate )
                end
            end
            frame.currentLoot.announced = true;
            btnAnnounce:Hide();
    end)
	btnAnnounce:SetPoint("LEFT",tbGPValueFrame,"RIGHT",10,0)
	btnAnnounce:SetHeight(25)
	btnAnnounce:SetWidth(120)
	btnAnnounce:SetText("Announce loot")
    frame.btnAnnounce = btnAnnounce;
    
    
    local drop = CreateFrame("Frame", "LootMasterMLCandidateDropDown", frame, "UIDropDownMenuTemplate");
    drop.addon = self;
    --#region Setup the popup menu for the candidate list
    drop:SetID(1)
    UIDropDownMenu_Initialize(drop, function(...) LootMasterML.CandidateDropDownInitialize(LootMasterML, ...) end, "MENU");    
    self.CandidateDropDown = drop;
    --#endregion
    
    mainframe:SetHeight( frame:GetHeight() )
    mainframe:SetWidth( frame:GetWidth() )    
    
    self.frame = frame;
    return self.frame    
end

function LootMasterML:EnterCombat()
    self.inCombat = true;
    if self:IsShown() then        
        self:Hide();
        self.hiddenOnCombat = true;
    end
end

function LootMasterML:LeaveCombat()
    self.inCombat = nil;
    if self.hiddenOnCombat then
        self:Show();
        self.hiddenOnCombat = nil;
    end;
end

function LootMasterML:IsShown()
    if not self.mainframe then return false end;
    
    if self.inCombat and self.hiddenOnCombat then return true end
    
    return self.mainframe:IsShown();
end

function LootMasterML:Show()
    if not self.mainframe then return false end;
    
    -- Lootmaster ui is shown... do nothing.
    if LootMaster and LootMaster.IsShown and LootMaster.IsShown(LootMaster) then
        return self.mainframe:Hide()
    end;
    
    -- Are we in combat? 
    if self.inCombat then
        -- Show the ui after combat
        self.mainframe:Hide();
        self.hiddenOnCombat = true;
        return true;
    end
    
    local ret = self.mainframe:Show();
    
    if self.frame.currentLoot then
        self:UpdateUI(self.frame.currentLoot.link);
    else
        self:UpdateUI();
    end   
    
    return ret;
end

function LootMasterML:Hide()
    if not self.mainframe then return end;
    return self.mainframe:Hide();
end

--[[
	Reload the scrollingtable if the current viewing item == link
]]
function LootMasterML:ReloadMLTableForLoot( itemName )
    
    -- LootMaster Loot UI visible? don't update
    if LootMaster and LootMaster.IsShown and LootMaster.IsShown(LootMaster) then return end;
    
    local frame = self:GetFrame();
    if not self.mainframe:IsShown() then
        self.mainframe:Show();
    end
    
    local lootData = self:GetLoot( itemName )
	if not lootData then
        return self:Print( tostring(itemName) .. ' not found when updating UI');
    end;
    
    self:UpdateUI( lootData.link );
    
end

function LootMasterML:CreateLootButton()
    
    local icon = CreateFrame("Button", nil, self.frame)
    --#region itemicon setup
    icon:EnableMouse()
    icon:SetNormalTexture("Interface/ICONS/INV_Misc_QuestionMark")
    icon:SetScript("OnEnter", function()
        if not icon.data then return end    
        GameTooltip:SetOwner(self.frame, "ANCHOR_NONE")
        GameTooltip:SetHyperlink( icon.data.link )
	    GameTooltip:Show()
        GameTooltip:SetPoint("TOPLEFT", self.frame , "TOPRIGHT", 0, -5);
    end);
    icon:SetScript("OnLeave", function()
	    GameTooltip:Hide()	
    end);
    icon:SetScript("OnClick", function()
        if not icon.data then return end
	    if ( IsModifiedClick() ) then
		    HandleModifiedItemClick(icon.data.link);
        else
            self:DisplayLoot(icon.data.link);
            self:UpdateUI();
        end
    end);
    icon:SetPoint("RIGHT",self.frame,"LEFT",-10,0)
    icon:SetHeight(LOOTBUTTON_HEIGHT)
    icon:SetWidth(LOOTBUTTON_HEIGHT)
    
    return icon;
end

function LootMasterML:DisplayLoot( item )
    
    local data = self:GetLoot(item);
        
    if not data then
        self.frame.currentLoot = nil;
        return
    end;
    
    self.frame.currentLoot = data;
    
    self.frame.lblItem:SetText(format('%s',data.link));
        
    local color = ITEM_QUALITY_COLORS[data.quality];
    if not color then
        color = {['r']=1,['g']=1,['b']=1}
    end
    self.frame.lblItem:SetVertexColor(color.r, color.g, color.b);
    
    local binding = '';
    if data.binding=='use' then
        binding = ', BoU'
    elseif data.binding=='pickup' then
        binding = ', BoP'
    elseif data.binding=='equip' then
        binding = ', BoE'
    end
    
    local gp2 = '';
    if data.gpvalue2 and data.gpvalue2~=0 then
        gp2 = format(' or %s', data.gpvalue2)
    end
    
    self.frame.lblInfo:SetText(format("ilevel: %s, GP: %s%s%s", data.ilevel or -1, data.gpvalue or -1, gp2, binding or ''));        
    self.frame.itemIcon:SetNormalTexture(data.texture); 
    
    self.frame.tbGPValue:SetText( data.gpvalue_manual )
    
    if not data.announced then
        self.frame.btnAnnounce:Show();
    else
        self.frame.btnAnnounce:Hide();
    end
    
    if data.mayDistribute then
        self.frame.tbGPValueFrame:Show();
        self.frame.lblGPOverride:Show();
        self.frame.lblNoDistribute:Hide();
    else
        self.frame.tbGPValueFrame:Hide();
        self.frame.lblGPOverride:Hide();
        self.frame.lblNoDistribute:Show();
        self.frame.lblNoDistribute:SetText( format("** MONITORING ** Only %s may distribute this item **", tostring(data.lootmaster)) )
    end
    
    self.frame.sstScroll:SetData( data.rowdata )    
    self.frame.sstScroll:SortData();
    self.frame.sstScroll:DoFilter();
end

function LootMasterML:UpdateUI( updateItemLink )
    
    if not self:IsShown() then return self:Debug('UpdateUI: not shown') end;
    
    local visibleLootButtons = 0;    
    local totalLoot = 0;   
    
    self:Debug('UpdateUI')
    
    if LootMaster and LootMaster.IsShown and LootMaster.IsShown(LootMaster) then return false end;
    
    -- Are we in combat? 
    if self.inCombat then
        -- Show the ui after combat
        self.mainframe:Hide();
        self.hiddenOnCombat = true;
        return true;
    end
    
    if updateItemLink and self.frame.currentLoot and self.frame.currentLoot.link==updateItemLink then
        -- We got a message to update the current displayed item, refresh the celldata.        
        self:Debug('update rows')
        self.frame.sstScroll:SetData( self.frame.currentLoot.rowdata )    
        self.frame.sstScroll:SortData();
        self.frame.sstScroll:DoFilter();
    end
    
    self:Debug('UpdateUI: Before loop')
    
    local breakMe = false
    
    for item, data in pairs(self.lootTable) do repeat
        self:Debug(format('UpdateUI: loop %s', item or 0))
        
        if item and data then
            
            -- If monitoring is disabled just don't display items we're not allowed to distribute.
            if not LootMaster.db.profile.monitor and not data.mayDistribute then
                -- also just remove the loot
                self:RemoveLoot(item)
                break
            end;
            
            totalLoot = totalLoot + 1;           
            
            if self.frame.currentLoot and data.link==self.frame.currentLoot.link then
                -- If already displaying, do nothing.
                self:Debug(format('%s already displaying, do nothing', data.link or 'nil'))
                breakMe = true;
                break;
            elseif not self.frame.currentLoot then
                -- Nothing is onscreen, display the first item
                self:Debug(format('displaying %s', data.link or 'nil'))
                self:DisplayLoot(item);
                breakMe = true;
                break;
            end
            
            if visibleLootButtons>=LOOTBUTTON_MAXNUM then breakMe = true; break end;
            visibleLootButtons = visibleLootButtons + 1;
            
            if not self.lootButtons then self.lootButtons = {} end;
            
            local lootButton = self.lootButtons[visibleLootButtons];
            if not lootButton then
                lootButton = self:CreateLootButton();
                self.lootButtons[visibleLootButtons] = lootButton;
            end
            
            self:Debug(format('button for %s', data.link or 'nil'))
            
            lootButton.data = data;
            lootButton:SetNormalTexture(data.texture);           
            lootButton:Show();
            
            lootButton:SetPoint( "TOP", self.frame, "TOP", 0, -20 - ((LOOTBUTTON_HEIGHT+LOOTBUTTON_PADDING) * (visibleLootButtons-1)) )
        end
    until true
        if breakMe then
            breakMe = false
        end
    
    end
    
    if breakMe then
        self:Print("Break doesn't work as expected, contact Author!")
    end
    
    self:Debug('UpdateUI: After loop')
    
    if self.lootButtons then 
        for i = visibleLootButtons+1, LOOTBUTTON_MAXNUM do
            local lootButton = self.lootButtons[i];
            if lootButton then
                self:Debug(format('hidden unused button #%s', i or 'nil'))
                lootButton.data = nil;
                lootButton:Hide()
            end
        end
    end;
    
    if totalLoot==0 and self:IsShown() then
        self:Debug(format('%s/%s but hidden', visibleLootButtons, totalLoot))
        self.frame.currentLoot = nil;
        self:Hide();
    else
        self:Debug(format('%s/%s displayed', visibleLootButtons, totalLoot))
    end
    
end

function LootMasterML:CandidateDropDownInitialize( frame, level, menuList )
        
    if not LootMasterML.CandidateDropDown then return end;
    
    local loot = LootMasterML.GetLoot( LootMasterML, LootMasterML.CandidateDropDown.selectedLink );
    
    if not loot then
        LootMasterML:Print(LootMasterML, 'could not display lootdropdown; loot not in table');
        return frame:Hide();
    end
    
    if self.frame then
        self.frame.tbGPValue:ClearFocus(); 
    end
    
    local info = UIDropDownMenu_CreateInfo();
    
    if LootMasterML and LootMasterML.CandidateDropDown and LootMasterML.CandidateDropDown.selectedCandidate then
        info.notCheckable = 1;
        info.isTitle = true;
        info.disabled = false;
        info.text = LootMasterML.CandidateDropDown.selectedCandidate;
        info.tooltipTitle = nil
        info.tooltipText = nil
        UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
        info=UIDropDownMenu_CreateInfo();    
        info.notCheckable = 1;
    end
    
    info.notCheckable = 1;
    info.disabled = false;
    info.text = 'Whisper';
    info.tooltipTitle = 'Whisper'
    info.tooltipText = 'Send a message to the selected candidate.'
	info.func = function() ChatFrame_SendTell(LootMasterML.CandidateDropDown.selectedCandidate) end;
	UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
    
    if loot.mayDistribute then
    
        info.isTitle = true;
        info.text = '';
        info.disabled = false;
        info.tooltipTitle = nil
        info.tooltipText = nil
        UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
        info=UIDropDownMenu_CreateInfo();    
        info.notCheckable = 1;
        
        info.isTitle = false;
        info.disabled = not CanEditOfficerNote();
        info.text = format( 'Give loot and award %s GP', loot.gpvalue_manual or 0 );
        info.tooltipTitle = info.text;
        info.tooltipText = format('Attempts to send the loot to the candidate and awards %s GP to the candidate', loot.gpvalue_manual or 0);
        info.func = function() LootMasterML.GiveLootToCandidate(LootMasterML, LootMasterML.CandidateDropDown.selectedLink, LootMasterML.CandidateDropDown.selectedCandidate, LootMaster.LOOTTYPE.GP, loot.gpvalue_manual or 0) end;
        UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
        
        if loot.gpvalue2 and loot.gpvalue2~=0 then
            info.isTitle = false;
            info.disabled = not CanEditOfficerNote();
            info.text = format( 'Give loot and award %s GP', loot.gpvalue2 or 0 );
            info.tooltipTitle = info.text;
            info.tooltipText = format('Attempts to send the loot to the candidate and awards %s GP to the candidate', loot.gpvalue2 or 0);
            info.func = function() LootMasterML.GiveLootToCandidate(LootMasterML, LootMasterML.CandidateDropDown.selectedLink, LootMasterML.CandidateDropDown.selectedCandidate, LootMaster.LOOTTYPE.GP, loot.gpvalue2 or 0) end;
            UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
        end
        
        info.isTitle = false;
        info.disabled = false;
        info.text = 'Give loot for free';
        info.tooltipTitle = 'Give loot for free';
        info.tooltipText = "Attempts to send the loot to the candidate and doesn't award GP to the candidate, thus giving it for free.";
        info.func = function() LootMasterML.GiveLootToCandidate(LootMasterML, LootMasterML.CandidateDropDown.selectedLink, LootMasterML.CandidateDropDown.selectedCandidate, LootMaster.LOOTTYPE.GP, 0 ) end;
        UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
        
        info.isTitle = false;
        info.disabled = false;
        info.text = 'Give loot for disenchantment';
        info.tooltipTitle = 'Give loot for disenchantment';
        info.tooltipText = 'Attempts to send the loot to the candidate for disenchantment.';
        info.func = function() LootMasterML.GiveLootToCandidate(LootMasterML, LootMasterML.CandidateDropDown.selectedLink, LootMasterML.CandidateDropDown.selectedCandidate, LootMaster.LOOTTYPE.DISENCHANT ) end;
        UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
        
        info.isTitle = false;
        info.disabled = false;
        info.text = 'Give loot for bank';
        info.tooltipTitle = 'Give loot for bank';
        info.tooltipText = 'Attempts to send the loot to the candidate for storage in bank.';
        info.func = function() LootMasterML.GiveLootToCandidate(LootMasterML, LootMasterML.CandidateDropDown.selectedLink, LootMasterML.CandidateDropDown.selectedCandidate, LootMaster.LOOTTYPE.BANK ) end;
        UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
        
        info.isTitle = true;
        info.disabled = false;
        info.text = '';
        info.tooltipTitle = nil
        info.tooltipText = nil
        UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
        info=UIDropDownMenu_CreateInfo();    
        info.notCheckable = 1;
        
        info.isTitle = false;
        info.disabled = false;
        info.text = '(Re)announce loot to candidate';
        info.tooltipTitle = '(Re)announce loot to candidate';
        info.tooltipText = 'Reopens the loot selection popup at the candidate, this offers the candidate to vote for the loot after a crash or disconnect.';
        info.func = function() LootMasterML.AskCandidateIfNeeded(LootMasterML, LootMasterML.CandidateDropDown.selectedLink, LootMasterML.CandidateDropDown.selectedCandidate) end;
        UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL); 
    
    end
    
    info.isTitle = true;
    info.disabled = false;
    info.text = '';
    info.tooltipTitle = nil
    info.tooltipText = nil
    UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
    info=UIDropDownMenu_CreateInfo();    
    info.notCheckable = 1;
    
    info.isTitle = false;
    info.disabled = false;
    info.text = '-DEBUG- Discard loot';
    info.tooltipTitle = nil;
    info.tooltipText = nil;
	info.func = function()
        LootMasterML.RemoveLoot(LootMasterML, LootMasterML.CandidateDropDown.selectedLink);
        LootMasterML.Show(LootMasterML);
    end;
	UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);

end

function LootMasterML:OnCandidateRowRightClick( candidate, link, row )
    self.CandidateDropDown.selectedCandidate = candidate;
    self.CandidateDropDown.selectedLink = link;
    self.CandidateDropDown.selectedRow = row;
    
    ToggleDropDownMenu(1, nil, self.CandidateDropDown, "cursor", 0, 0);
end

function LootMasterML:SetCellEPGPNumberFormatted( cell, self, candidate, func )
    local value = func(self, candidate)
    if not value or value == -1 then return cell.text:SetText('?'); end;    
    cell.text:SetText(format("%.4g", tonumber(value) or 0 ));
end

function LootMasterML:EmptyCellOwnerDraw(cell)
    if not cell then return end;
    cell.text:SetText('')
end

function LootMasterML:SetGearCellOwnerDraw(cell, itemData)
    
    if not itemData or itemData=='' then
        cell.text:SetText('');
        cell:SetNormalTexture(nil)
        return;
    end   
    
    local link, gpvalue, ilevel, gpvalue2, itemTexture = strsplit("^", itemData)
    
    cell.text:SetText('');
    cell:SetNormalTexture(itemTexture)
end

function LootMasterML:ShowGearCellPopup( candidate, item, dataName )
    
    local itemData = self:GetCandidateData(item, candidate, dataName);
    if not itemData or itemData=='' then return end;
    
    local link, gpvalue, ilevel, gpvalue2, itemTexture = strsplit("^", itemData);
    
    GameTooltip:SetOwner(self.frame, "ANCHOR_NONE")
    GameTooltip:SetHyperlink( link )
	GameTooltip:Show()
    GameTooltip:SetPoint("TOPLEFT", self.frame , "TOPRIGHT", 0, -5);
    
end

function LootMasterML:ShowRollCellPopup( candidate, item )
    
    local roll = self:GetCandidateData(item, candidate, 'roll');
    if not roll then return end;
    
    GameTooltip:SetOwner(self.frame, "ANCHOR_NONE")
    GameTooltip:AddLine('This value is only needed if two candidates have the same PR.')
    GameTooltip:AddLine('It is just a simple random roll to decide who gets the loot')
    GameTooltip:AddLine( format('%s rolled %s.', candidate, roll))
	GameTooltip:Show()
    GameTooltip:SetPoint("TOPLEFT", self.frame , "TOPRIGHT", 0, -5);
    
end

function LootMasterML:SetGearCelliLVL( cell, self, candidate, item )
    local s = {};
    local itemData = self:GetCandidateData(item, candidate, "currentitem");
    local _, _, ilevel, _, _ = strsplit("^", itemData or '');
    if ilevel then tinsert(s, ilevel) end
    
    
    itemData = self:GetCandidateData(item, candidate, "currentitem2");
    _, _, ilevel, _, _ = strsplit("^", itemData or '');
    if ilevel then tinsert(s, ilevel) end
    
    cell.text:SetText( strjoin(', ', unpack(s)))   
end

function LootMasterML:SetGearCellGP( cell, self, candidate, item )    
    local s = {};
    local itemData = self:GetCandidateData(item, candidate, "currentitem");
    local _, gpvalue, _, _, _ = strsplit("^", itemData or '');
    if gpvalue then tinsert(s, gpvalue) end    
    
    itemData = self:GetCandidateData(item, candidate, "currentitem2");
    _, gpvalue, _, _, _ = strsplit("^", itemData or '');
    if gpvalue then tinsert(s, gpvalue) end
    
    cell.text:SetText( strjoin(', ', unpack(s)))
end

function LootMasterML:SetCandidateEPGPCellUserDraw( cell, self, candidate, item )
    if not EPGP or not EPGP.GetEPGP then
        return cell.text:SetText( '-ep/gp-' );
    end
    local ok, ep, gp, main = pcall(EPGP.GetEPGP, EPGP, candidate)
    if not ok then
        return cell.text:SetText( '?' );
    end
    cell.text:SetText( format('%s/%s', tostring(ep), tostring(gp)) );
end

function LootMasterML:GetCandidateCellColor( candidate, item, dataName, defaultColor )
    --local itemData = self:GetCandidateData( item, candidate, "version" );
    
    local r, g, b = self:GetCandidateResponseColor( candidate, item, nil );
    return {["r"] = r or 1, ["g"] = g or 0, ["b"] = b or 1, ["a"] = 1.0 };
end

function LootMasterML:GetCandidateResponseColor( candidate, item, response )
    if not response then
        response = tonumber(self:GetCandidateData(item, candidate, "response"));
    end
    
    if not response or not LootMaster.RESPONSE[response] then
        return 1,0,1
    end
    
    return unpack( LootMaster.RESPONSE[response].COLOR or {1,0,1} )    
end

function LootMasterML:SetCandidateResponseCellUserDraw( cell, self, candidate, item )
    local response = tonumber(self:GetCandidateData(item, candidate, "response"));
      
    if response == LootMaster.RESPONSE.DISENCHANT then
        cell.text:SetText( format('Pass; Enchanter (%s)',self:GetCandidateData(item, candidate, "enchantingSkill") or 0) );
        
    elseif LootMaster.RESPONSE[response] then
        cell.text:SetText( LootMaster.RESPONSE[response].TEXT );
        
    else
        cell.text:SetText( 'resp: ' .. self:GetCandidateData(item, candidate, "response"));
    end
end

function LootMasterML:SetCandidateRollCellUserDraw( cell, self, candidate, item )
    local roll = self:GetCandidateData(item, candidate, "roll");    
      
    if roll then
        cell.text:SetText( floor(roll) );        
    else
        cell.text:SetText( '?' );
    end
end

function LootMasterML:HideGearCellPopup( candidate, item, dataName )
    GameTooltip:Hide()
end

function LootMasterML:OnGearCellClick( candidate, item, dataName )
    if ( IsModifiedClick() ) then
        local link, _, _, _, _ = strsplit("^", self:GetCandidateData(item, candidate, dataName) or '');
		HandleModifiedItemClick(link);
    end
end
